<script setup lang="ts">
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import RouteNavigationDrawer from '@/shared/administration/components/RouteNavigationDrawer.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { ref, watch } from 'vue'
    import SListItem from '@/shared/item/components/SListItem.vue'
    import { InterventionServiceOffer } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOffer'
    import { InterventionServiceOfferApi } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOfferApi'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const interventionServiceOffers = ref<InterventionServiceOffer[]>([])
    const interventionServiceOfferApi = new InterventionServiceOfferApi(msal)
    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isLoading.value = true
            interventionServiceOfferApi
                .getAll()
                .then(
                    (returnedInterventionServiceOffers) =>
                        (interventionServiceOffers.value =
                            returnedInterventionServiceOffers)
                )
                .finally(() => (isLoading.value = false))
        },
        { immediate: true }
    )
</script>

<template>
    <route-navigation-drawer page-title="Offres de service Intervention" />
    <v-main>
        <s-content-container>
            <h2 class="pt-3">
                {{ interventionServiceOffers.length }} offres de service
                intervention
            </h2>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading"
            ></v-skeleton-loader>
            <v-list>
                <template
                    v-for="(
                        interventionServiceOffer, index
                    ) in interventionServiceOffers"
                    :key="interventionServiceOffer.id"
                    ><v-divider v-if="index > 0"></v-divider>
                    <s-list-item
                        :item="interventionServiceOffer"
                        :to="{
                            name: 'admin/ods-intervention/modifier',
                            params: { id: interventionServiceOffer.id },
                        }"
                    />
                </template>
            </v-list>

            <s-action-button
                icon="mdi-plus"
                label="Ajouter une ODS"
                data-cy="create-intervention-service-offer"
                display="floating-fixed"
                position="right"
                :to="{
                    name: 'admin/ods-intervention/créer',
                }"
            >
            </s-action-button>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
